import scala.collection.mutable.ArrayBuffer
import java.util.Calendar
import java.text.SimpleDateFormat

class Pedido (val cliente:Cliente){
	val items = new ArrayBuffer[(Int, Item)]
	val timestamp = Calendar.getInstance().getTime()
	val dateFormat = new SimpleDateFormat("dd/MM/yyyy")
	val timeFormat = new SimpleDateFormat("HH:mm")
	val date = dateFormat.format(timestamp)
	val time = timeFormat.format(timestamp)

	def addItem(quant:Int, item:Item) = {
		items.append((quant, item))
	}
	//def delItem(item) = {
		//
	//}

	def total() = {
		var total:Float = 0
		for(item <- items) total += item._1 * item._2.preco
		total
	}

	override def toString() = {
		List(cliente.nome, cliente.telefone, date, time).mkString(";")+";"+"%.2f".format(total).replace('.',',')
	}
}